/*
	$Date: 1997/12/18 17:24:27 $
	$Revision: 1.8 $
*/
#pragma pack(2)

#include <stdio.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include <System/FeatureMgr.h>

#include "asearch.h"
#include "search.h"
#include "id.h"

static Boolean Lock(void);
static void Unlock(void);
static void OpenAsearch(Global *g);
static void CloseAsearch(Global *g);
static Boolean AppHandleEvent(Global *g,EventPtr e);
static void InsertToMainField(Global *g, char *s);
static void EraseCand(Global *g);
static void SearchCand(Global *g, int kind);

////////////////////////////////////////////////////////////
//		$B%a%$%s%k!<%A%s(B
////////////////////////////////////////////////////////////

void ASearch()
{
	FormPtr frm;
	void (*oldtrap)(int);
	EventType event;
	Global *g;

	// Hack$B8F$S=P$7%"%W%j$,J8;zF~NO>uBV$+$I$&$+%A%'%C%/(B
	if((frm = FrmGetActiveForm()) == NULL) return;
	if(FrmGetFocus(frm) == -1) return;

	// Hack$B$,=E$M$F8F$S=P$5$l$k$?$H$-$O$b$H$N%i%$%V%i%j$r8F=P$7(B
	if(! Lock()){
		DWord ftrvalue;
		FtrGet(APPTYPE,1000,&ftrvalue);
		oldtrap = (void (*)(int))ftrvalue;
		(*oldtrap)(0);
		return;
	}

	// $B%0%m!<%P%k%G!<%?NN0h3NJ](B
	g = (Global*)MemPtrNew(sizeof(Global));
	ErrFatalDisplayIf(g==NULL,"Can't alloc global data");

	// $B<-=q%G!<%?%Y!<%9%*!<%W%s(B
	g->edic = DmOpenDatabaseByTypeCreator('DICt','ASRC',
		dmModeReadOnly);
	ErrFatalDisplayIf(g->edic==0,"Can't open edic");

	OpenAsearch(g); // ASearch$B2hLL=i4|2=(B

	// ASearch$B$N%$%Y%s%H=hM}%k!<%W(B
	g->finish = false;
	do {
		Word error;
		EvtGetEvent(&event, evtWaitForever);
		if (AppHandleEvent(g,&event)) continue;
		if (SysHandleEvent(&event)) continue;
		if (MenuHandleEvent(NULL, &event, &error)) continue;
		FrmDispatchEvent(&event);
	}
	while (! g->finish && event.eType != appStopEvent);
	if(event.eType == appStopEvent){
		EvtAddEventToQueue(&event);
	}

	CloseAsearch(g); // ASearch$B2hLL=*N;(B

	DmCloseDatabase(g->edic);
	MemPtrFree(g);
	Unlock();
}

////////////////////////////////////////////////////////////
//		ASearch$B2hLL3+;O(B/$B=*N;(B
////////////////////////////////////////////////////////////

static Boolean MainFormEvent(EventPtr e) // $B%@%_!<(B
{
	return false;
}

static void OpenAsearch(Global *g)
{
	Word idx;

	// Form$B$r8F$S$@$;$k$h$&$K$9$k$?$a$K6&DL%G!<%?%Y!<%9$r%*!<%W%s(B
	g->db = DmOpenDatabaseByTypeCreator('HACK','ASRC',
		dmModeReadWrite);
	ErrFatalDisplayIf(g->db==NULL,"Can't open ASearch DB");

	g->asfrm = FrmInitForm(ID_MAINFORM);
	ErrFatalDisplayIf(g->asfrm==NULL,"Can't init Form");

	FrmSetEventHandler(g->asfrm, MainFormEvent);
	FrmSetActiveForm(g->asfrm);

	EraseCand(g);

	FrmDrawForm(g->asfrm);

	idx = FrmGetObjectIndex(g->asfrm,ID_PATFIELD);
	FrmSetFocus(g->asfrm,idx);
	g->patfield = FrmGetObjectPtr(g->asfrm,idx);
}

static void CloseAsearch(Global *g)
{
	FrmReturnToForm(NULL); // $B%"%W%j%1!<%7%g%s2hLL$KI|5"(B
	DmCloseDatabase(g->db);
}

////////////////////////////////////////////////////////////
//		ASearch$B$N%$%Y%s%H=hM}(B
////////////////////////////////////////////////////////////

static Boolean AppHandleEvent(Global *g,EventPtr e)
{
	Boolean handled = true;
	Word c;
	int button;

	switch(e->eType){
	case ctlSelectEvent:
		c = e->data.ctlSelect.controlID;
		switch(c){
		case ID_BUTTON_DONE:
			g->finish = true;
			break;
		case ID_BUTTON1:	case ID_BUTTON2:
		case ID_BUTTON3:	case ID_BUTTON4:
		case ID_BUTTON5:	case ID_BUTTON6:
		case ID_BUTTON7:	case ID_BUTTON8:
		case ID_BUTTON9:	case ID_BUTTON10:
			button = c - ID_BUTTON;
			InsertToMainField(g, g->candstr[button]);
			break;
		default:
			handled = false;
			break;
		}
	case keyDownEvent:
		c = e->data.keyDown.chr;
		if(c == pageUpChr){ // $B>e%9%/%m!<%k%\%?%s(B
			SearchCand(g,PREVCAND); // $BA08uJdI=<((B
		}
		else if(c == pageDownChr){ // $B2<%9%/%m!<%k%\%?%s(B
			SearchCand(g,NEXTCAND); // $B<!8uJdI=<((B
		}
		else if(c == '\n'){
			char *s = FldGetTextPtr(g->patfield);
			if(s){
				char buf[100];
				StrCopy(buf,s);
				InsertToMainField(g,buf);
			}
			else
				InsertToMainField(g,"\n");
		}
		else if(c >= 0x20 && c < 0x80){
			char cc = (char)c;
			FldInsert(g->patfield,&cc,1);
			SearchCand(g,NEWCAND);
		}
		else
			handled = false;
		break;
	default:
		handled = false;
		break;
	}
	return handled;
}

////////////////////////////////////////////////////////////
//		Lock/Unlock
////////////////////////////////////////////////////////////

static Boolean Lock(void) // Hack$B$NFs=E8F=P$rHr$1$k%m%C%/(B
{
	DWord locked;
	Err err = FtrGet(APPTYPE,FEATURE_LOCK,&locked);
	if(err || locked == 0){
		FtrSet(APPTYPE,FEATURE_LOCK,1); // Lock
		return true;
	}
	return false;
}

static void Unlock(void)
{
	FtrSet(APPTYPE,FEATURE_LOCK,0); // UnLock
}

////////////////////////////////////////////////////////////
//		$B8uJdC18lI=<((B
////////////////////////////////////////////////////////////

static void EraseCand(Global *g) // $B8uJd%/%j%d(B
{
	int i;
	g->ncands = 0;
	g->candpos = 0;
	for(i=0;i<MAXCANDS;i++){
		Word idx = FrmGetObjectIndex(g->asfrm,ID_BUTTON+i);
		CtlHideControl(FrmGetObjectPtr(g->asfrm,idx));
		g->candstr[i][0] = '\0';
	}
}

static Boolean AddCand(Global *g,unsigned char *cstr)
//
//	cstr$B$r8uJd%j%9%H$K2C$($FI=<(!#M>M5$,$J$1$l$P(Bfalse$B$rJV$9!#(B
//
{
	int i, width;
	ControlPtr cp;
	Word idx;

	if(g->ncands >= MAXCANDS) return false;

	// $B4{$K$=$N8tJd$,8tJd%j%9%H$K$"$l$P2?$b$7$J$$(B
	for(i=0;i<g->ncands;i++)
		if(StrCompare(cstr,g->candstr[i]) == 0)
			return true;

	// $B?7$7$$8uJdJ8;zNs$r%\%?%s$KEPO?(B/$BI=<((B
	width = FntCharsWidth(cstr,StrLen(cstr)) + 4;
	if(g->candpos + 2 + width >= 156) return false;
	StrCopy(g->candstr[g->ncands],cstr);
	idx = FrmGetObjectIndex(g->asfrm,ID_BUTTON+g->ncands);
	cp = FrmGetObjectPtr(g->asfrm,idx);
	cp->bounds.topLeft.x = g->candpos + 2;
	cp->bounds.extent.x = width;
	cp->text = g->candstr[g->ncands];
	CtlShowControl(cp);

	g->candpos += width+3;
	g->ncands++;
	return true;
}

static void SearchCand(Global *g, int kind)
//
//	$BF0E*[#Kf8!:w$r<B9T$7$F8uJdC18l%j%9%H$rI=<((B
//
{
	Char pat[100],*s,*p,*s0;
	int resid;
	VoidHand h;
	Boolean found;
	ULong size;
	int mismatch; // $B[#KfEY(B

	switch(kind){
	case NEWCAND:
		g->candindex = 0;
		g->candoffset[0] = 0;
		break;
	case NEXTCAND:
		if(g->candindex >= MAXCANDPAGES-1) return;
		g->candindex++;
		break;
	case PREVCAND:
		if(g->candindex <= 0) return;
		g->candindex--;
		break;
	default:
	}

	if((s = FldGetTextPtr(g->patfield)) == NULL) return;

	for(p=pat;*s;s++){
		if((*s >= 'a' && *s <= 'z') || *s == ' ') *p++ = *s;
		if(*s >= 'A' && *s <= 'Z') *p++ = (*s + 'a' - 'A');
	}
	StrCopy(p," ");

	resid = (int)(pat[0] - 'a' + 1);
	if(resid < 1 || resid > 'z'-'a'+1) return;

	h = DmGetResource ('EDIC',resid);
	ErrFatalDisplayIf(h==0,"Can't get EDIC resource");
	s0 = MemHandleLock(h);
	ErrFatalDisplayIf(s==0,"Can't lock EDIC resource");
	size = MemPtrSize(s0);

	for(mismatch=0;mismatch<3;mismatch++){  // $BF0E*[#Kf8!:w<B9T(B
		EraseCand(g);
		MakePat(g,pat,mismatch);
		found = false;
		s = s0 + g->candoffset[g->candindex];
		while(s-s0 < size){
			if(Match(g,s)){
				found = true;
				if(! AddCand(g,s)) break;
			}
			for(;*s;s++);
			s++;
		}
		if(found) break;
	}

	if(g->candindex+1 < MAXCANDPAGES)
		g->candoffset[g->candindex+1] = s - s0;

	MemHandleUnlock(h);
	DmReleaseResource(h);
}

////////////////////////////////////////////////////////////
//		$BA*BrC18l$NE=$jIU$1(B
////////////////////////////////////////////////////////////

static void InsertToMainField(Global *g, char *s)
//
//  ASearch$B$N%U%)!<%`$r40A4$KJD$8$F$b$H$N%U%#!<%k%I$KC18lA^F~(B
//
{
	LocalID id;
	VoidPtr v;
	FormPtr frm;
	FieldPtr field;
	FormObjectKind kind;
		       
	CloseAsearch(g);

	frm = FrmGetActiveForm();
	id = FrmGetFocus(frm);
	v = FrmGetObjectPtr(frm,id);
	kind = FrmGetObjectType(frm,id);
	field = (kind == frmFieldObj ? v :
		 kind == frmTableObj ? TblGetCurrentField(v) :
		 NULL);
	if(field) FldInsert(field,s,StrLen(s));

	OpenAsearch(g);
}
