//
//	$Date: 1997/12/15 13:20:50 $
//	$Revision: 1.2 $
//
#include "search.h"

void MakePat(Global *g, unsigned char *pat, int mismatch)
{
	int i;
	unsigned int mask = INITPAT;

	g->mismatch = mismatch;
	g->epsilon = 0;

	for(i=0;i<MAXCHAR;i++) g->shiftpat[i] = 0;
	for(;*pat;pat++){
		if(*pat == ' '){ // $B%o%$%k%I%+!<%IJ8;z(B
			g->epsilon |= mask;
		}
		else {
			g->shiftpat[*pat] |= mask;
			mask >>= 1;
		}
	}
	g->acceptpat = mask;
}

int Match(Global *g, register unsigned char *text)
{
	register unsigned int i0 = INITPAT, i1=0, i2=0, i3=0;
	register unsigned int mask;
	register unsigned int e = g->epsilon;

	for(;*text;text++){
		mask = g->shiftpat[*text];
		i3 = (i3 & e) | ((i3 & mask) >> 1) | (i2 >> 1) | i2;
		i2 = (i2 & e) | ((i2 & mask) >> 1) | (i1 >> 1) | i1;
		i1 = (i1 & e) | ((i1 & mask) >> 1) | (i0 >> 1) | i0;
		i0 = (i0 & e) | ((i0 & mask) >> 1);
		i1 |= (i0 >> 1);
		i2 |= (i1 >> 1);
		i3 |= (i2 >> 1);
	}
	switch(g->mismatch){
		case 0: return (i0 & g->acceptpat);
		case 1: return (i1 & g->acceptpat);
		case 2: return (i2 & g->acceptpat);
		case 3: return (i3 & g->acceptpat);
		default: return 0;
	}
}
